football.analyzer<-function(){
#########START OF MATRIX OR DATA FRAME VALIDATION###########
if(exists("log.filename",envir=.GlobalEnv)) {rm(log.filename,envir=.GlobalEnv)}
if(exists("remain",envir=.GlobalEnv)) {rm(remain,envir=.GlobalEnv)}
if(exists("pre.exit.routine",envir=.GlobalEnv)) {rm(pre.exit.routine,envir=.GlobalEnv)}
object.names<-ls(envir=.GlobalEnv)
acceptable<-FALSE
require(tcltk) || stop("tcltk support is absent")
require(stats)
t1<-tktoplevel() ####BUILDING THE OBJECT LIST
tkwm.title(t1,"Select the data matrix")
object.list.scroll<-tkscrollbar(t1,command=function(...)tkyview(object.list,...))
object.list<-tklistbox(t1,width=40,yscrollcommand=function(...)tkset(object.list.scroll,...))
for (i in object.names) {
	tkinsert(object.list,"end",i)
}
tkselection.set(object.list,0)
tkgrid(tklabel(t1,text="Objects Available:"),columnspan=2)
tkgrid(object.list,object.list.scroll)
tkgrid.configure(object.list.scroll,sticky="wns") #####OBJECT LIST READY
data.matrix.selection<-function() {#####WHEN SELECTION BUTTON FOR LIST PRESSED
test<-object.names[as.numeric(tkcurselection(object.list))+1]
object.sel<-get(test)
while (acceptable==FALSE) {####TESTING THE MATRIX PROVIDED
	if (is.matrix(object.sel)==T | is.data.frame(object.sel)==T) {
		if (dim(object.sel)[2]==4) {
			non.nas3<-(1:dim(object.sel)[1])[!is.na(object.sel[,3])]
			non.nas4<-(1:dim(object.sel)[1])[!is.na(object.sel[,4])]
			if (sum(as.numeric(object.sel[non.nas3,3])%%1==0)==dim(object.sel[non.nas3,])[1] & sum(as.numeric(object.sel[non.nas4,4])%%1==0)==dim(object.sel[non.nas4,])[1]) {###ATTENTION ON MISSING VALUES OMIT IF THERE ARE NAs, NA%%1=PROBLEM####
			acceptable<<-TRUE}else{tkmessageBox(message=paste("The score columns (last 2) do not appear to be valid score values (integers).","\n","Please select a valid object.",sep=""),title="Invalid Score Values",icon="error",type="ok");break;}
		}else{tkmessageBox(message=paste("The matrix or data frame should consist of 4 columns:","\n","    - 2 for each team name and","\n","    - 2 for their corresponding goals scored.","\n","Please select a valid object.",sep=""),title="Invalid Object Format",icon="error",type="ok");break}
	}else{tkmessageBox(message=paste("A matrix or a data frame is required.","\n","Please select a valid object.",sep=""),title="Invalid Object",icon="error",type="ok");break}
	if (acceptable==TRUE) { ###THE MATRIX IS VALID
		tkconfigure(t1,cursor="watch")
		tkconfigure(button.ok,cursor="watch")
		scoring.teams<-c(as.character(object.sel[,1]),as.character(object.sel[,2]))
		opposing.teams<-c(as.character(object.sel[,2]),as.character(object.sel[,1]))
		scores<-c(object.sel[,3],object.sel[,4])
		home.effect<-rep(c(1,0),each=length(scoring.teams)/2)
		dedomena<-data.frame(cbind(scoring.teams,opposing.teams,scores,home.effect))
		modelo<-glm(as.integer(as.character(dedomena$scores))~dedomena$scoring.teams+dedomena$opposing.teams+dedomena$home.effect,family=poisson(link=log))
		all.teams<-levels(factor(c(as.character(dedomena$scoring.teams),as.character(dedomena$opposing.teams))))
		no.coefs<-length(names(modelo$coef))
		modelo.pnames<-c(names(modelo$coef)[c(1,no.coefs)],paste("dedomena$scoring.teams",all.teams[1],sep=""),names(modelo$coef)[2:(no.coefs/2)],paste("dedomena$opposing.teams",all.teams[1],sep=""),names(modelo$coef)[(no.coefs/2+1):(no.coefs-1)])
		modelo.coef<-c(modelo$coef[c(1,no.coefs)],0,modelo$coef[2:(no.coefs/2)],0,modelo$coef[(no.coefs/2+1):(no.coefs-1)])
		tkconfigure(button.ok,cursor="hand2")
		tkconfigure(t1,cursor="")
		tkdestroy(t1) ####THE REST OF THE PROGRAM HERE
#####INITIAL ANALYSIS MENU
tt<-tktoplevel()
master.choice<-tclVar(0)
tkwm.title(tt,"Football Analyser")
tkfocus(tt)
frame.base<-tkframe(tt,relief="ridge",borderwidth=3)
frame.2nd<-tkframe(frame.base,relief="ridge",borderwidth=3)
tkgrid(tklabel(tt,text="Available Choices for Analysis:",font=tkfont.create(family="times",size=12,weight="bold")),columnspan=2)
for (temp in c("Predict Future Games", "Predict Final Score", "Performance Plot", "Model Parameters", "Reproduction of Final Rank")) {
	master.radio.box.options<-tkradiobutton(frame.2nd,text=temp,value=temp,variable=master.choice)
	tkpack(master.radio.box.options,anchor="w")
}
tclvalue(master.choice)<-"Predict Future Games"
tkgrid(frame.2nd,columnspan=2)
tkgrid(frame.base,columnspan=2)
chooselogfile<-function() { #####LOG FILE DEFINITION FUNCTION
	log.filename<<-tkgetSaveFile(initialfile=paste(test,format.Date(Sys.time(),"%d-%m-%Y")),defaultextension="{.falog} {.txt}",filetypes="{{Football Analyzer Log Files} {.falog}} {{Simple Text Files} {.txt}} {{All Files} *}")
	if (tclvalue(log.filename)!="") { ###IF A FILENAME HAS BEEN DEFINED
		tkconfigure(button.log,font=tkfont.create(family="times",size=12))
		tkconfigure(button.proceed,state="normal",cursor="hand2")
		tkfocus(tt)
	}else{ ####ELSE IF AN EMPTY SELECTION IS REMADE RESET THE BUTTONS
		tkconfigure(button.log,font=tkfont.create(family="times",size=12,weight="bold"))
		tkconfigure(button.proceed,state="disabled",cursor="")
		tkfocus(tt)
	}#####END OF CHECK IF THERE IS A FILENAME TO SAVE TO
} #####END OF LOG FILE DEFINITION FUNCTION
button.log<-tkbutton(tt,text="Choose the log file...",cursor="pencil",font=tkfont.create(family="times",weight="bold",size=12),command=chooselogfile)
tkgrid(tklabel(tt,text=" ")) ###EMPTY LINE FOR MORE SPACE
tkgrid(button.log,columnspan=2) #####LOG FILE BUTTON
master.choice.check<-function() { #######MAJOR FUNCTION - CHECK WHICH OPTION IS SELECTED
if (tclvalue(master.choice)=="Predict Future Games") {####PREDICT FUTURE GAMES
	pfg<-tktoplevel()
	tkwm.title(pfg,"Predict Future Games")
	tkfocus(pfg)
	tkgrid(tklabel(pfg,text="Available Teams:"),tklabel(pfg,text=" "),tklabel(pfg,text="Selected Home Teams:"),tklabel(pfg,text="VS",font=tkfont.create(size=12,weight="bold")),tklabel(pfg,text="Selected Visitor Teams:"))
	scroll.list.home<-tkscrollbar(pfg,command=function(...)tkyview(list.home,...))
	list.home<-tklistbox(pfg,width=35,yscrollcommand=function(...)tkset(scroll.list.home,...))
	scroll.list.pfg.teams<-tkscrollbar(pfg,command=function(...)tkyview(list.pfg.teams,...))
	list.pfg.teams<-tklistbox(pfg,width=35,yscrollcommand=function(...)tkset(scroll.list.pfg.teams,...))
	scroll.list.visit<-tkscrollbar(pfg,command=function(...)tkyview(list.visit,...))
	list.visit<-tklistbox(pfg,width=35,yscrollcommand=function(...)tkset(scroll.list.visit,...))

	tkgrid(list.pfg.teams,scroll.list.pfg.teams,list.home,scroll.list.home,list.visit,scroll.list.visit)
	tkgrid.configure(scroll.list.home,sticky="wns")
	tkgrid.configure(scroll.list.pfg.teams,sticky="wns")
	tkgrid.configure(scroll.list.visit,sticky="wns")
	for (i in all.teams) {
		tkinsert(list.pfg.teams,"end",i)
	}
	function.button.home<-function() {#####HOME TEAMS ADD/REMOVE LIST BUTTON FUNCTION
		if (!is.na(as.integer(tclvalue(tkcurselection(list.pfg.teams))))) {
			tkinsert(list.home,"end",all.teams[as.integer(tclvalue(tkcurselection(list.pfg.teams)))+1])
		}
		if (!is.na(as.integer(tclvalue(tkcurselection(list.home))))) {
			tkdelete(list.home,as.integer(tclvalue(tkcurselection(list.home))))
		}
		if (as.integer(tclvalue(tkindex(list.home,"end")))==as.integer(tclvalue(tkindex(list.visit,"end"))) & as.integer(tclvalue(tkindex(list.home,"end")))!=0) {
			tkconfigure(button.predict,state="normal",cursor="hand2")
		}else{tkconfigure(button.predict,state="disabled",cursor="")}
	} #####END OF HOME TEAMS ADD/REMOVE LIST BUTTON FUNCTION
	function.button.visit<-function() {#####VISITOR TEAMS ADD/REMOVE LIST BUTTON FUNCTION
		if (!is.na(as.integer(tclvalue(tkcurselection(list.pfg.teams))))) {
			tkinsert(list.visit,"end",all.teams[as.integer(tclvalue(tkcurselection(list.pfg.teams)))+1])
		}
		if (!is.na(as.integer(tclvalue(tkcurselection(list.visit))))) {
			tkdelete(list.visit,as.integer(tclvalue(tkcurselection(list.visit))))
		}
		if (as.integer(tclvalue(tkindex(list.home,"end")))==as.integer(tclvalue(tkindex(list.visit,"end"))) & as.integer(tclvalue(tkindex(list.home,"end")))!=0) {
			tkconfigure(button.predict,state="normal",cursor="hand2")
		}else{tkconfigure(button.predict,state="disabled",cursor="")}
	} #####END OF VISITOR TEAMS ADD/REMOVE LIST BUTTON FUNCTION
	button.home<-tkbutton(pfg,text="Add/Remove to/from Home Teams list",cursor="hand1",command=function.button.home)
	button.visit<-tkbutton(pfg,text="Add/Remove to/from Visitor Teams list",cursor="hand1",command=function.button.visit)
	function.button.predict<-function() {####PREDICT BUTTON
		list.length<-as.integer(tclvalue(tkindex(list.home,"end")))
		home.teams.sel<-NULL
		visit.teams.sel<-NULL
		for (i in 1:list.length-1) {
			home.teams.sel<-c(home.teams.sel,tclvalue(tkget(list.home,i)))
			visit.teams.sel<-c(visit.teams.sel,tclvalue(tkget(list.visit,i)))
		}
		if (sum(home.teams.sel==visit.teams.sel)==0) {###NO TEAM SELECTED AS BOTH HOME AND VISITOR IN ANY GAME
			#####ACTUAL PREDICTING GAMES CODE
			tkconfigure(pfg,cursor="watch")
			tkconfigure(button.predict,cursor="watch")
			pfg.res<-tktoplevel()
			tkwm.title(pfg.res,"Game Predictions")
			pfg.res.text.scr<-tkscrollbar(pfg.res, repeatinterval=5,command=function(...)tkyview(pfg.res.text,...))
			pfg.res.text<-tktext(pfg.res,bg="white",font="courier",yscrollcommand=function(...)tkset(pfg.res.text.scr,...))
			tkinsert(pfg.res.text,"end",paste("GAME PREDICTION RESULTS","\n","\n",sep=""))
			for (i in 1:length(home.teams.sel)) {
				boot.home<-rpois(1000,exp(modelo.coef[modelo.pnames==paste("dedomena$scoring.teams",home.teams.sel[i],sep="")]+modelo.coef[modelo.pnames==paste("dedomena$opposing.teams",visit.teams.sel[i],sep="")]+modelo.coef[modelo.pnames=="dedomena$home.effect1"]))
				boot.visit<-rpois(1000,exp(modelo.coef[modelo.pnames==paste("dedomena$scoring.teams",visit.teams.sel[i],sep="")]+modelo.coef[modelo.pnames==paste("dedomena$opposing.teams",home.teams.sel[i],sep="")]))
				tkinsert(pfg.res.text,"end",paste("In the game of ",home.teams.sel[i]," (HOME TEAM) against ",visit.teams.sel[i]," (VISITOR)","\n","it is estimated that: ","\n","\n", "-The probability of ",home.teams.sel[i]," winning against ",visit.teams.sel[i]," is ",sum(boot.home>boot.visit)/10,"%","\n"," with ",round(mean(boot.home),1)," average goals scored.","\n","-The probability of ",home.teams.sel[i]," losing to ",visit.teams.sel[i]," is ",sum(boot.visit>boot.home)/10,"%","\n"," with ",round(mean(boot.visit),1)," average goals received.","\n","-The probability of a tie between ",home.teams.sel[i]," and ",visit.teams.sel[i]," is ",sum(boot.home==boot.visit)/10,"%","\n","********************************************************************************","\n",sep=""))
			}
			tkconfigure(pfg,cursor="")
			tkconfigure(button.predict,cursor="hand2")
			tkgrid(pfg.res.text,pfg.res.text.scr,columnspan=4)
			tkgrid.configure(pfg.res.text.scr,sticky="nws")
			tkconfigure(pfg.res.text,state="disabled")
			save.exit<-function(){
				cat(date(),tclvalue(tkget(pfg.res.text,"0.0","end")),sep="\n",file=tclvalue(log.filename),append=TRUE)
				tkdestroy(pfg.res)
			}
			save.exit.button<-tkbutton(pfg.res,text="Save Results to log & Close",command=save.exit,cursor="hand2",font=tkfont.create(size=14,weight="bold",family="times",slant="italic"))
			tkgrid(save.exit.button,tkbutton(pfg.res,text="Exit without saving",cursor="X_cursor",command=function()tkdestroy(pfg.res)),columnspan=2)
			tkfocus(pfg.res)
			copyText <- function() tcl("event","generate",.Tk.ID(pfg.res.text),"<<Copy>>")
			txt.pop.menu<-tkmenu(pfg.res.text, tearoff=FALSE)
			tkadd(txt.pop.menu, "command", label="Copy <Ctrl-C>",command=copyText)
			tkadd(txt.pop.menu,"separator")
			tkadd(txt.pop.menu, "command", label="Save & Close <Enter>",command=save.exit)
			tkadd(txt.pop.menu, "command", label="Exit & Don't Save <Esc>",command=function()tkdestroy(pfg.res))
			right.click.pop <- function(x,y) {# x, y: mouse coordinates
				rootx <- as.integer(tkwinfo("rootx",pfg.res.text))
				rooty <- as.integer(tkwinfo("rooty",pfg.res.text))
				xTxt <- as.integer(x)+rootx
				yTxt <- as.integer(y)+rooty
				tcl("tk_popup",txt.pop.menu,xTxt,yTxt)
			}
			pfg.res.text.scrolling<-function(D) {
				if (D<0) {tkyview(pfg.res.text,"scroll","+1","units")}
				if (D>0) {tkyview(pfg.res.text,"scroll","-1","units")}
			}
			pre.exit.routine<<-function(){
				per.val<-tkmessageBox(title="Output Window Shutting Down", message=paste("You are about to leave the output screen without saving the results to the log file.","\n","Would you like to save to log before doing so?",sep=""),type="yesnocancel",icon="question")
				if (tclvalue(per.val)=="yes") {save.exit()}
				if (tclvalue(per.val)=="no") {tkdestroy(pfg.res)}
				tkfocus(pfg)
			}
			tcl("wm", "protocol", pfg.res, "WM_DELETE_WINDOW", quote(pre.exit.routine()))
			tkbind(pfg.res.text,"<MouseWheel>",pfg.res.text.scrolling)
			tkbind(pfg.res.text, "<Button-3>",right.click.pop)
			tkbind(pfg.res,"<Return>",save.exit)
			tkbind(pfg.res,"<Escape>",function()tcl("event","generate",.Tk.ID(pfg.res),"<Alt-F4>")) ####ESCAPE BUTTONS EXITS
			####END OF ACTUAL PREDICTING GAMES CODE
		}else {tkmessageBox(title="Team Selection Error",message="Invalid matching of teams! You have created a game where a team plays against itself.",icon="error",type="ok")}
	}####END OF PREDICT BUTTON
	button.predict<-tkbutton(pfg,text="Make the Prediction",command=function.button.predict,state="disabled",font=tkfont.create(family="times",size=14,weight="bold",slant="italic"))
	function.button.reset<-function() {#####RESET LIST BUTTON FUNCTION
	temp<-as.integer(tclvalue(tkindex(list.home,"end")))
	for (i in 0:temp) {
		tkdelete(list.home,0)
	}
	temp<-as.integer(tclvalue(tkindex(list.visit,"end")))
	for (i in 0:temp) {
		tkdelete(list.visit,0)
	}
	tkconfigure(button.predict,state="disabled",cursor="")
	}#####END OF RESET BUTTON FUNCTION
	button.reset<-tkbutton(pfg,text="Reset Team Lists",cursor="exchange",command=function.button.reset)

	tkgrid(tklabel(pfg,text=" "),tklabel(pfg,text=" "),button.home,tklabel(pfg,text=" "),button.visit)
	tkgrid(tklabel(pfg,text=" "))
	tkgrid(button.reset,tklabel(pfg,text=" "),button.predict,tklabel(pfg,text=" "),tkbutton(pfg,text="   Exit   ",cursor="X_cursor",command=function()tkdestroy(pfg)))
	list.focused<-tclVar(0)
	tkbind(list.pfg.teams,"<Enter>",function()tclvalue(list.focused)<-1)
	tkbind(list.home,"<Enter>",function()tclvalue(list.focused)<-2)
	tkbind(list.visit,"<Enter>",function()tclvalue(list.focused)<-3)
	list.scrolling<-function(D) {#####MOUSE WHEEL SCROLLING ALL LISTS
		if (tclvalue(list.focused)==1) {#MOUSE OVER TEAM LIST
			if (D<0) {tkyview(list.pfg.teams,"scroll","+1","units")}
			if (D>0) {tkyview(list.pfg.teams,"scroll","-1","units")}
		}
		if (tclvalue(list.focused)==2) {#MOUSE OVER HOME TEAM LIST
			if (D<0) {tkyview(list.home,"scroll","+1","units")}
			if (D>0) {tkyview(list.home,"scroll","-1","units")}
		}
		if (tclvalue(list.focused)==3) {#MOUSE OVER VISITOR TEAM LIST
			if (D<0) {tkyview(list.visit,"scroll","+1","units")}
			if (D>0) {tkyview(list.visit,"scroll","-1","units")}
		}
	}#####END OF MOUSE WHEEL SCROLLING ALL LISTS
	tkbind(pfg,"<MouseWheel>",list.scrolling)
	enter.button.choices.pfg<-function() {####WHEN ENTER IS PRESSED
		if (tclvalue(tkcget(button.predict,"-state"))=="normal") {function.button.predict()}
	}####END OF WHEN ENTER IS PRESSED
	tkbind(pfg,"<Return>",enter.button.choices.pfg) ###ENTER BUTTON SUBMITS
	tkbind(pfg,"<Escape>",function()tkdestroy(pfg)) ####ESCAPE BUTTON EXITS
}#######END OF PREDICT FUTURE GAMES CHOICE
if (tclvalue(master.choice)=="Performance Plot") {####PERFORMANCE PLOT
	perf.plot<-tktoplevel()
	tkwm.title(perf.plot,"Performance Plot")
	tkfocus(perf.plot)
	tkgrid(tklabel(perf.plot,text="Available Teams:"),columnspan=3)
	scroll.list.perf.plot<-tkscrollbar(perf.plot,command=function(...)tkyview(list.perf.plot,...))
	list.perf.plot<-tklistbox(perf.plot,width=35,yscrollcommand=function(...)tkset(scroll.list.perf.plot,...))
	tkgrid(list.perf.plot,scroll.list.perf.plot,columnspan=3)
	tkgrid.configure(scroll.list.perf.plot,sticky="wns")
	for (i in all.teams) {
		tkinsert(list.perf.plot,"end",i)
	}
	tkselection.set(list.perf.plot,0)
	function.button.perf.plot<-function() {#####DRAW PLOT BUTTON FUNCTION
		team4plot<-all.teams[as.integer(tclvalue(tkcurselection(list.perf.plot)))+1]
		orig.data<-object.sel
		if (tclvalue(as.home)=="1") { ####DEFINE HOME TEAM
			index4plot<-orig.data[,1]==team4plot
			our.scores<-orig.data[,3][index4plot]
			their.scores<-orig.data[,4][index4plot]
			team4enemy<-orig.data[,2][index4plot]
			team.kind<-"as a home team"
		}else{
			index4plot<-orig.data[,2]==team4plot
			our.scores<-orig.data[,4][index4plot]
			their.scores<-orig.data[,3][index4plot]
			team4enemy<-orig.data[,1][index4plot]
			team.kind<-"as a visitor team"
		} ####END OF HOME TEAM DEFINITION
		if (tclvalue(draw.errorbars)==0) {###DRAW LINE POT
			if (max(our.scores)>=max(their.scores)) {#THE TOP OF THE CHART MUST BE VISIBLE. TEAM WITH HIGHER GOALS MUST BE PLOTTED FIRST
				plot(our.scores,col="blue",type="l",main=paste("Performance Plot of",team4plot,team.kind),xlab="Games' Succession",ylab="Number of Goals")
				legend(1,max(c(our.scores,their.scores)),pch="_",legend=c(paste("Goals Scored by",team4plot),paste("Goals",team4plot,"Received")),col=c("blue","red"))
				lines(their.scores,col="red",type="l")
			}else{
				plot(their.scores,col="red",type="l",main=paste("Performance Plot of",team4plot,team.kind),xlab="Games' Succession",ylab="Number of Goals")
				legend(1,max(c(our.scores,their.scores)),pch="_",legend=c(paste("Goals Scored by",team4plot),paste("Goals",team4plot,"Received")),col=c("blue","red"))
				lines(our.scores,col="blue",type="l")}
		}else{###DRAW ERROR-BARS
			plot(c(1,length(our.scores)),c(0,max(our.scores,their.scores)),type="n",main=paste("Performance Plot of",team4plot,team.kind),xlab="Games' Succession",ylab="Number of Goals")
			legend(1,max(c(our.scores,their.scores)),pch="_",legend=c(paste("Goals Scored by",team4plot),paste("Goals",team4plot,"Received")),col=c("blue","red"))
			for (i in 1:length(our.scores)){
				polygon(c(i,i),c(our.scores[i],their.scores[i]))
				polygon(c(i+0.2,i-0.2),c(our.scores[i],our.scores[i]),border="blue")
				polygon(c(i+0.2,i-0.2),c(their.scores[i],their.scores[i]),border="red")
			}
		}###END OF DRAWING
		if (tclvalue(identify.later)=="0") {###IDENTIFY ALL POINTS OR NOT
			text(our.scores,labels=team4enemy)
		}else{
			identify(our.scores,labels=team4enemy)
		}####END OF IDENTIFY OR NOT
	}#####END OF DRAW PLOT BUTTON FUNCTION
	button.perf.plot<-tkbutton(perf.plot,text="Draw the Plot",command=function.button.perf.plot,cursor="hand2",font=tkfont.create(family="times",size=14,weight="bold",slant="italic"))
	as.home<-tclVar("1")
	tkgrid(tkradiobutton(perf.plot,text="As a home team",value="1",variable=as.home),tkradiobutton(perf.plot,text="As a visitor team",value="0",variable=as.home))
	identify.later<-tclVar("0")
	tkgrid(tkcheckbutton(perf.plot,text=paste("Don't name all the teams.","\n","I will select the ones to be named.",sep=""),variable=identify.later),columnspan=2)
	draw.errorbars<-tclVar("0")
	tkgrid(tkcheckbutton(perf.plot,text=paste("Don't draw a line plot.","\n","Use error-bar plot instead.",sep=""),variable=draw.errorbars),columnspan=2)
	tkgrid(tklabel(perf.plot,text=" "))
	tkgrid(button.perf.plot,tklabel(perf.plot,text=" "),tkbutton(perf.plot,text="Exit",cursor="X_cursor",command=function()tkdestroy(perf.plot)),columnspan=2)
	mouse.scrolling<-function(D) {###MOUSE WHEEL SCROLLING
		if (D<0) {tkyview(list.perf.plot,"scroll","+1","units")}
		if (D>0) {tkyview(list.perf.plot,"scroll","-1","units")}
	}###END OF MOUSE WHEEL SCROLLING
	tkbind(perf.plot,"<MouseWheel>",mouse.scrolling)
	tkbind(perf.plot,"<Return>",function.button.perf.plot)
	tkbind(perf.plot,"<Escape>",function()tkdestroy(perf.plot))
}######END OF PERFORMANCE PLOT
if (tclvalue(master.choice)=="Model Parameters") {#####MODEL PARAMETERS
	mod.est<-tktoplevel()
	tkwm.title(mod.est,"Model Estimated Parameters")
	tkfocus(mod.est)
	est.text.scr<-tkscrollbar(mod.est, repeatinterval=5,command=function(...)tkyview(est.text,...))
	est.text<-tktext(mod.est,bg="white",font="courier",yscrollcommand=function(...)tkset(est.text.scr,...))
	tkinsert(est.text,"end",paste("MODEL PARAMETERS VIEW","\n",sep=""))
	tkinsert(est.text,"end",paste("Parameters as estimated by the model: ","\n","\n",sep=""))
	tkinsert(est.text,"end",paste(modelo.pnames[1]," = ",round(modelo.coef[1],3),"\n",sep=""))
	tkinsert(est.text,"end",paste(substr(modelo.pnames[2],10,20)," = ",round(modelo.coef[2],3),"\n","\n",sep=""))
	tkinsert(est.text,"end",paste("TEAM NAME           ","ATTACKING SKILLS    ","DEFENSIVE SKILLS    ","\n",sep=""))
	n<-length(modelo.pnames)-2
	clean.teams<-strtrim(paste(unlist(strsplit(modelo.pnames[-2:-1],"teams"))[(1:(82*2))%%2==0],"                    ",sep=""),20)
	round.params<-strtrim(paste(as.character(round(modelo.coef[-2:-1],3)),"                    ",sep=""),20)
	for (i in 1:(n/2)) {
		tkinsert(est.text,"end",paste(clean.teams[i],round.params[i],round.params[i+n/2],"\n",sep=""))
	}
	tkinsert(est.text,"end",paste("********************************************************************************","\n",sep=""))
	tkconfigure(tt,cursor="")
	tkconfigure(button.proceed,cursor="hand2")	
	tkgrid(est.text,est.text.scr,columnspan=4)
	tkgrid.configure(est.text.scr,sticky="nsw")
	tkconfigure(est.text,state="disabled")
	save.exit<-function(){
		cat(date(),tclvalue(tkget(est.text,"0.0","end")),sep="\n",file=tclvalue(log.filename),append=TRUE)
		tkdestroy(mod.est)
		tkfocus(tt)
	}
	txt.pop.menu<-tkmenu(est.text, tearoff=FALSE)
	tkadd(txt.pop.menu, "command", label="Copy <Ctrl-C>",command=function() tcl("event","generate",.Tk.ID(est.text),"<<Copy>>"))
	tkadd(txt.pop.menu,"separator")
	tkadd(txt.pop.menu, "command", label="Save & Close <Enter>",command=save.exit)
	tkadd(txt.pop.menu, "command", label="Exit & Don't Save <Esc>",command=function()tkdestroy(mod.est))
	right.click.pop <- function(x,y) {# x, y: mouse coordinates
		rootx <- as.integer(tkwinfo("rootx",est.text))
		rooty <- as.integer(tkwinfo("rooty",est.text))
		xTxt <- as.integer(x)+rootx
		yTxt <- as.integer(y)+rooty
		tcl("tk_popup",txt.pop.menu,xTxt,yTxt)
	}
	tkgrid(tkbutton(mod.est,text="Save Results to log & Close",command=save.exit,cursor="hand2",font=tkfont.create(size=14,weight="bold",family="times",slant="italic")),tkbutton(mod.est,text="Exit without saving",cursor="X_cursor",command=function()tkdestroy(mod.est)),columnspan=2)
	pre.exit.routine<<-function(){
		per.val<-tkmessageBox(title="Output Window Shutting Down", message=paste("You are about to leave the output screen without saving the results to the log file.","\n","Would you like to save to log before doing so?",sep=""),type="yesnocancel",icon="question")
		if (tclvalue(per.val)=="yes") {save.exit()}
		if (tclvalue(per.val)=="no") {tkdestroy(mod.est)}
		tkfocus(tt)
	}
	tcl("wm", "protocol", mod.est, "WM_DELETE_WINDOW", quote(pre.exit.routine()))
	tkbind(est.text, "<Button-3>",right.click.pop)
	tkbind(mod.est,"<Return>",save.exit)
	tkbind(mod.est,"<Escape>",function()tcl("event","generate",.Tk.ID(mod.est),"<Alt-F4>")) ####ESCAPE BUTTONS EXITS
}#####END OF MODEL PARAMETERS
if (tclvalue(master.choice)=="Predict Final Score") {#####FINAL SCORE PREDICTION
	pfs<-tktoplevel()
	tkwm.title(pfs,"Final Score Prediction")
	tkfocus(pfs)
	tkgrid(tklabel(pfs,text="Available Teams:"),tklabel(pfs,text=" "),tklabel(pfs,text="Teams participating in the tournament:"),tklabel(pfs,text=" "))
	scroll.list.all.pfs<-tkscrollbar(pfs,command=function(...)tkyview(list.all.pfs,...))
	list.all.pfs<-tklistbox(pfs,width=35,yscrollcommand=function(...)tkset(scroll.list.all.pfs,...))
	scroll.list.sel.pfs<-tkscrollbar(pfs,command=function(...)tkyview(list.sel.pfs,...))
	list.sel.pfs<-tklistbox(pfs,width=35,yscrollcommand=function(...)tkset(scroll.list.sel.pfs,...))
	tkgrid(list.all.pfs,scroll.list.all.pfs,list.sel.pfs,scroll.list.sel.pfs)
	tkgrid.configure(scroll.list.all.pfs,sticky="nsw")
	tkgrid.configure(scroll.list.sel.pfs,sticky="nsw")
	for (i in all.teams) {
		tkinsert(list.all.pfs,"end",i)
	}
	remain<<-all.teams
	button.add.remove.function<-function() {
		if (!is.na(as.integer(tclvalue(tkcurselection(list.all.pfs))))) {##ADD TO SELECTION
			pos.sel<-as.integer(tclvalue(tkcurselection(list.all.pfs)))
			remain<<-remain[-pos.sel-1]
			if (tclvalue(enter.as)=="Home") {team.status<-"--> Home"}
			if (tclvalue(enter.as)=="Visitor") {team.status<-"--> Visitor"}
			if (tclvalue(enter.as)=="Both") {team.status<-"--> Both"}
			tkinsert(list.sel.pfs,"end",paste(tclvalue(tkget(list.all.pfs,pos.sel)),team.status))
			tkdelete(list.all.pfs,pos.sel)
		}
		if (!is.na(as.integer(tclvalue(tkcurselection(list.sel.pfs))))) {##REMOVE FROM SELECTION
			pos.sel<-as.integer(tclvalue(tkcurselection(list.sel.pfs)))
			team.name<-unlist(strsplit(tclvalue(tkget(list.sel.pfs,pos.sel))," --> "))[1]
			remain<<-sort(c(remain,team.name))
			tkdelete(list.sel.pfs,pos.sel)
			pos2put<-(1:length(remain))[remain==team.name]
			tkinsert(list.all.pfs,pos2put-1,team.name)
		}
		if (as.integer(tclvalue(tkindex(list.sel.pfs,"end")))>1) {###ADJUST THE BUTTON STATE
			tkconfigure(but.pfs,state="normal",cursor="hand2")
		}else{
			tkconfigure(but.pfs,state="disabled",cursor="")
		}
	}
	button.all.function<-function() {
		if (as.integer(tclvalue(tkindex(list.sel.pfs,"end")))>0) {
			for (i in 1:as.integer(tclvalue(tkindex(list.sel.pfs,"end")))){
				tkdelete(list.sel.pfs,0)###CLEAR SELECT LIST
			}
			for (i in 1:as.integer(tclvalue(tkindex(list.all.pfs,"end")))){
				tkdelete(list.all.pfs,0)###CLEAR ALL LIST
			}
			for (i in all.teams) {
				tkinsert(list.all.pfs,"end",i)###WRITE WHOLE LIST IN ALL
			}
			remain<<-all.teams
		}else{
			if (tclvalue(enter.as)=="Home") {team.status<-"--> Home"}
			if (tclvalue(enter.as)=="Visitor") {team.status<-"--> Visitor"}
			if (tclvalue(enter.as)=="Both") {team.status<-"--> Both"}
			for (i in 1:as.integer(tclvalue(tkindex(list.all.pfs,"end")))){
				tkdelete(list.all.pfs,0)####CLEAR ALL LIST
			}
			for (i in all.teams) {
				tkinsert(list.sel.pfs,"end",paste(i,team.status))###WRITE WHOLE LIST IN SELECT
			}
			remain<<-NULL
		}
		if (as.integer(tclvalue(tkindex(list.sel.pfs,"end")))>1) {
			tkconfigure(but.pfs,state="normal",cursor="hand2")
		}else{
			tkconfigure(but.pfs,state="disabled",cursor="")
		}
	}
	tkgrid(tkbutton(pfs,text="Add/Remove Team",cursor="hand1",command=button.add.remove.function),tklabel(pfs,text=" "),tkbutton(pfs,text="Add/Remove All",cursor="sb_h_double_arrow",command=button.all.function),tklabel(pfs,text=" "))
	button.pfs<-function() {
		if (tclvalue(tkcurselection(list.sel.pfs))=="") {
			tkmessageBox(title="No Team Selected",message=paste("You must select a team whose final score will be calculated","\n","against the rest of the teams in this virtual tournament."),type="ok",icon="error")
		}else{######MAIN SCORE PREDICTION ROUTINE
			tkconfigure(pfs,cursor="watch")
			tkconfigure(but.pfs,cursor="watch")
			scopre<-tktoplevel()
			tkwm.title(scopre,paste("Final Score Prediction for",unlist(strsplit(tclvalue(tkget(list.sel.pfs,tclvalue(tkcurselection(list.sel.pfs))))," --> "))[1]))
			tkfocus(scopre)
			scopre.text.scr<-tkscrollbar(scopre, repeatinterval=5,command=function(...)tkyview(scopre.text,...))
			scopre.text<-tktext(scopre,bg="white",font="courier",yscrollcommand=function(...)tkset(scopre.text.scr,...))
			tkgrid(scopre.text,scopre.text.scr,columnspan=4)
			tkgrid.configure(scopre.text.scr,sticky="nsw")
			tkinsert(scopre.text,"end",paste("SCORE PREDICTION RESULTS","\n",sep=""))
			main.team.pos<-as.integer(tclvalue(tkcurselection(list.sel.pfs)))
			main.team<-unlist(strsplit(tclvalue(tkget(list.sel.pfs,main.team.pos))," --> "))[1]
			no.teams<-as.integer(tclvalue(tkindex(list.sel.pfs,"end")))
			home.teams<-NULL
			visit.teams<-NULL
			for (i in (1:no.teams-1)[-main.team.pos-1]) {
				cur.team.info<-unlist(strsplit(tclvalue(tkget(list.sel.pfs,i))," --> "))
				if (cur.team.info[2]=="Home") {
					home.teams<-c(home.teams,cur.team.info[1])
					visit.teams<-c(visit.teams,main.team)
				}
				if (cur.team.info[2]=="Visitor") {
					home.teams<-c(home.teams,main.team)
					visit.teams<-c(visit.teams,cur.team.info[1])
				}
				if (cur.team.info[2]=="Both") {
					home.teams<-c(home.teams,cur.team.info[1])
					visit.teams<-c(visit.teams,main.team)
					home.teams<-c(home.teams,main.team)
					visit.teams<-c(visit.teams,cur.team.info[1])
				}
			}
			score<-0
			exp.score<-0
			tkinsert(scopre.text,"end",paste(main.team," is most likely to:","\n",sep=""))
			for (i in 1:length(home.teams)) {
				boot.home<-rpois(1000,exp(modelo.coef[modelo.pnames==paste("dedomena$scoring.teams",home.teams[i],sep="")]+modelo.coef[modelo.pnames==paste("dedomena$opposing.teams",visit.teams[i],sep="")]+modelo.coef[modelo.pnames=="dedomena$home.effect1"]))
				boot.visit<-rpois(1000,exp(modelo.coef[modelo.pnames==paste("dedomena$scoring.teams",visit.teams[i],sep="")]+modelo.coef[modelo.pnames==paste("dedomena$opposing.teams",home.teams[i],sep="")]))
				if (home.teams[i]==main.team) {
					cases.vic<-sum(boot.home>boot.visit)
					cases.loss<-sum(boot.home<boot.visit)
					cases.draw<-sum(boot.home==boot.visit)
					outcome<-max(cases.vic,cases.loss,cases.draw)
					exp.score<-exp.score+(3*cases.vic+1*cases.draw)/1000
					if (cases.vic==outcome) {
						score<-score+3
						tkinsert(scopre.text,"end",paste("- Win against " ,visit.teams[i]," (VISITOR) thus gaining 3 points","\n",sep=""))
						if(tclvalue(detailed.view)=="1" && tclvalue(prodds)=="odds") {tkinsert(scopre.text,"end",paste("  with expected score results: ",round(mean(boot.home),1)," - ",round(mean(boot.visit),1)," and odds of winning: ",round(cases.vic/(cases.loss+cases.draw),2)," with\n  the probability of a tie reaching: ",round(cases.draw/10,2),"%\n",sep=""))}
						if(tclvalue(detailed.view)=="1" && tclvalue(prodds)=="probs") {tkinsert(scopre.text,"end",paste("  with expected score results: ",round(mean(boot.home),1)," - ",round(mean(boot.visit),1)," and probability of winning: ",round(cases.vic/10,2),"%\n",sep=""))}
					}
					if (cases.draw==outcome) {
						score<-score+1
						tkinsert(scopre.text,"end",paste("- Draw against " ,visit.teams[i]," (VISITOR) thus gaining 1 points","\n",sep=""))
						if(tclvalue(detailed.view)=="1" && tclvalue(prodds)=="odds") {tkinsert(scopre.text,"end",paste("  with expected score results: ",round(mean(boot.home),1)," - ",round(mean(boot.visit),1)," and odds of drawing: ",round(cases.draw/(cases.loss+cases.vic),2),"\n",sep=""))}
						if(tclvalue(detailed.view)=="1" && tclvalue(prodds)=="probs") {tkinsert(scopre.text,"end",paste("  with expected score results: ",round(mean(boot.home),1)," - ",round(mean(boot.visit),1)," and probability of winning: ",round(cases.draw/10,2),"%\n",sep=""))}
					}
					if (cases.loss==outcome) {
						tkinsert(scopre.text,"end",paste("- Lose against " ,visit.teams[i]," (VISITOR) thus gaining 0 points","\n",sep=""))
						if(tclvalue(detailed.view)=="1" && tclvalue(prodds)=="odds") {tkinsert(scopre.text,"end",paste("  with expected score results: ",round(mean(boot.home),1)," - ",round(mean(boot.visit),1)," and odds of losing: ",round(cases.loss/(cases.vic+cases.draw),2)," with\n  the probability of a tie reaching: ",round(cases.draw/10,2),"%\n",sep=""))}
						if(tclvalue(detailed.view)=="1" && tclvalue(prodds)=="probs") {tkinsert(scopre.text,"end",paste("  with expected score results: ",round(mean(boot.home),1)," - ",round(mean(boot.visit),1)," and probability of losing: ",round(cases.loss/10,2),"%\n",sep=""))}
					}
				}
				if (visit.teams[i]==main.team) {
					cases.vic<-sum(boot.home<boot.visit)
					cases.loss<-sum(boot.home>boot.visit)
					cases.draw<-sum(boot.home==boot.visit)
					outcome<-max(cases.vic,cases.loss,cases.draw)
					exp.score<-exp.score+(3*cases.vic+1*cases.draw)/1000
					if (cases.vic==outcome) {
						score<-score+3
						tkinsert(scopre.text,"end",paste("- Win against " ,home.teams[i]," (HOME TEAM) thus gaining 3 points","\n",sep=""))
						if(tclvalue(detailed.view)=="1" && tclvalue(prodds)=="odds") {tkinsert(scopre.text,"end",paste("  with expected score results: ",round(mean(boot.visit),1)," - ",round(mean(boot.home),1)," and odds of winning: ",round(cases.vic/(cases.loss+cases.draw),2)," with\n  the probability of a tie reaching: ",round(cases.draw/10,2),"%","\n",sep=""))}
						if(tclvalue(detailed.view)=="1" && tclvalue(prodds)=="probs") {tkinsert(scopre.text,"end",paste("  with expected score results: ",round(mean(boot.visit),1)," - ",round(mean(boot.home),1)," and probability of winning: ",round(cases.vic/10,2),"%","\n",sep=""))}
					}
					if (cases.draw==outcome) {
						score<-score+1
						tkinsert(scopre.text,"end",paste("- Draw against " ,home.teams[i]," (HOME TEAM) thus gaining 1 points","\n",sep=""))
						if(tclvalue(detailed.view)=="1" && tclvalue(prodds)=="odds") {tkinsert(scopre.text,"end",paste("  with expected score results: ",round(mean(boot.visit),1)," - ",round(mean(boot.home),1)," and odds of drawing: ",round(cases.draw/(cases.loss+cases.vic),2),"\n"))}
						if(tclvalue(detailed.view)=="1" && tclvalue(prodds)=="probs") {tkinsert(scopre.text,"end",paste("  with expected score results: ",round(mean(boot.visit),1)," - ",round(mean(boot.home),1)," and probability of winning: ",round(cases.draw/10,2),"%\n",sep=""))}
					}
					if (cases.loss==outcome) {
						tkinsert(scopre.text,"end",paste("- Lose against " ,home.teams[i]," (HOME TEAM) thus gaining 0 points","\n",sep=""))
						if(tclvalue(detailed.view)=="1" && tclvalue(prodds)=="odds") {tkinsert(scopre.text,"end",paste("  with expected score results: ",round(mean(boot.visit),1)," - ",round(mean(boot.home),1)," and odds of losing: ",round(cases.loss/(cases.vic+cases.draw),2)," with\n  the probability of a tie reaching: ",round(cases.draw/10,2),"%","\n",sep=""))}
						if(tclvalue(detailed.view)=="1" && tclvalue(prodds)=="probs") {tkinsert(scopre.text,"end",paste("  with expected score results: ",round(mean(boot.visit),1)," - ",round(mean(boot.home),1)," and probability of losing: ",round(cases.loss/10,2),"%\n",sep=""))}
					}
				}
			}
			tkinsert(scopre.text,"end",paste("\nTOTAL GAMES PLAYED: ",length(home.teams),"\n",sep=""))
			tkinsert(scopre.text,"end",paste("TOTAL PREDICTED SCORE: ",score,"\n",sep=""))
			tkinsert(scopre.text,"end",paste("TOTAL EXPECTED SCORE: ",round(exp.score,1),"\n",sep=""))
			if(tclvalue(detailed.view)=="1" && tclvalue(prodds)=="odds") {tkinsert(scopre.text,"end",paste("\nNOTE: The odds above are calculated as the probability of the outcome most\nlikely to happen (e.g. win) against the other two possible outcomes\n(e.g. loss and tie).\n",sep=""))}
			tkinsert(scopre.text,"end",paste("********************************************************************************","\n",sep=""))
			tkconfigure(pfs,cursor="")
			tkconfigure(scopre.text,state="disabled")
			tkconfigure(but.pfs,cursor="hand2")
			save.exit<-function(){
				cat(date(),tclvalue(tkget(scopre.text,"0.0","end")),sep="\n",file=tclvalue(log.filename),append=TRUE)
				tkdestroy(scopre)
			}
			txt.pop.menu<-tkmenu(scopre.text, tearoff=FALSE)
			tkadd(txt.pop.menu, "command", label="Copy <Ctrl-C>",command=function() tcl("event","generate",.Tk.ID(scopre.text),"<<Copy>>"))
			tkadd(txt.pop.menu,"separator")
			tkadd(txt.pop.menu, "command", label="Save & Close <Enter>",command=save.exit)
			tkadd(txt.pop.menu, "command", label="Exit & Don't Save <Esc>",command=function()tkdestroy(scopre))
			right.click.pop <- function(x,y) {# x, y: mouse coordinates
				rootx <- as.integer(tkwinfo("rootx",scopre.text))
				rooty <- as.integer(tkwinfo("rooty",scopre.text))
				xTxt <- as.integer(x)+rootx
				yTxt <- as.integer(y)+rooty
				tcl("tk_popup",txt.pop.menu,xTxt,yTxt)
			}
			tkgrid(tkbutton(scopre,text="Save Results to log & Close",command=save.exit,cursor="hand2",font=tkfont.create(size=14,weight="bold",family="times",slant="italic")),tkbutton(scopre,text="Exit without saving",cursor="X_cursor",command=function()tkdestroy(scopre)),columnspan=2)
			pre.exit.routine<<-function(){
				per.val<-tkmessageBox(title="Output Window Shutting Down", message=paste("You are about to leave the output screen without saving the results to the log file.","\n","Would you like to save to log before doing so?",sep=""),type="yesnocancel",icon="question")
				if (tclvalue(per.val)=="yes") {save.exit()}
				if (tclvalue(per.val)=="no") {tkdestroy(scopre)}
				tkfocus(pfs)
			}
			tcl("wm", "protocol", scopre, "WM_DELETE_WINDOW", quote(pre.exit.routine()))
			tkbind(scopre.text, "<Button-3>",right.click.pop)
			tkbind(scopre,"<Return>",save.exit)
			tkbind(scopre,"<Escape>",function()tcl("event","generate",.Tk.ID(scopre),"<Alt-F4>")) ####ESCAPE BUTTONS EXITS

		}
	}
	list.focused<-tclVar(0)
	tkbind(list.all.pfs,"<Enter>",function()tclvalue(list.focused)<-1)
	tkbind(list.sel.pfs,"<Enter>",function()tclvalue(list.focused)<-2)
	list.scrolling<-function(D) {#####MOUSE WHEEL SCROLLING ALL LISTS
		if (tclvalue(list.focused)==1) {#MOUSE OVER TEAM LIST
			if (D<0) {tkyview(list.all.pfs,"scroll","+1","units")}
			if (D>0) {tkyview(list.all.pfs,"scroll","-1","units")}
		}
		if (tclvalue(list.focused)==2) {#MOUSE OVER HOME TEAM LIST
			if (D<0) {tkyview(list.sel.pfs,"scroll","+1","units")}
			if (D>0) {tkyview(list.sel.pfs,"scroll","-1","units")}
		}
	}#####END OF MOUSE WHEEL SCROLLING ALL LISTS
	tkbind(pfs,"<MouseWheel>",list.scrolling)
	but.pfs<-tkbutton(pfs,text="Predict Final Score",command=button.pfs,font=tkfont.create(family="times",size=14,weight="bold",slant="italic"),state="disabled",cursor="")
	enter.as<-tclVar("Home")
	tkgrid(tklabel(pfs,text="This team enters as:"),columnspan=4)
	frame.enter.as<-tkframe(pfs,relief="ridge",border=1)
	tkgrid(tkradiobutton(frame.enter.as,value="Home",text="a home team",variable=enter.as),sticky="w")
	tkgrid(tkradiobutton(frame.enter.as,value="Visitor",text="a visitor team",variable=enter.as),sticky="w")
	tkgrid(tkradiobutton(frame.enter.as,value="Both",text="both home and visitor team",variable=enter.as),sticky="w")
	tkgrid(frame.enter.as,columnspan=4)
	tkgrid(tklabel(pfs,text="(Note: This will not be taken into account for the team of interest.)"),columnspan=4)
	tkgrid(tklabel(pfs,text=" "))
	detailed.view<-tclVar("0")
	detail.frame<-tkframe(pfs,relief="groove",borderwidth=2)
	prodds<-tclVar("odds")
	rbodds<-tkradiobutton(detail.frame,text="Show Odds",variable=prodds,value="odds",state="disabled")
	rbprob<-tkradiobutton(detail.frame,text="Show Probabilities",variable=prodds,value="probs",state="disabled")
	details.panel<-function() {
		if (tclvalue(detailed.view)=="0") {
			tkconfigure(rbodds,state="disabled")
			tkconfigure(rbprob,state="disabled")
		}else{
			tkconfigure(rbodds,state="normal")
			tkconfigure(rbprob,state="normal")
		}
	}
	tkgrid(tkcheckbutton(pfs,text="Show Detailed Information",variable=detailed.view,command=details.panel),columnspan=4)
	tkgrid(detail.frame,columnspan=4)
	tkgrid(rbodds,rbprob,columnspan=4)
	tkgrid(tklabel(pfs,text=" "))
	tkgrid(but.pfs,columnspan=4)
	tkgrid(tkbutton(pfs,text="Exit",command=function()tkdestroy(pfs),cursor="X_cursor"),row=10,column=3)
	tkbind(pfs,"<Escape>",function()tkdestroy(pfs)) ####ESCAPE BUTTON EXITS
	pre.button.pfs<-function() {##TO AVOID BUTTON STATE OVERRIDE USING THE RETURN KEY
		if (tclvalue(tkcget(but.pfs,"-state"))=="normal") {button.pfs()}
	}
	tkbind(pfs,"<Return>",pre.button.pfs) ###ENTER CALLS PRE-MAIN ROUTINE
}#####END OF FINAL SCORE PREDICTION
if (tclvalue(master.choice)=="Reproduction of Final Rank") {###REPRODUCTION OF FINAL RANK
	rfr<-tktoplevel()
	tkwm.title(rfr,"Final Rank Reproduction")
	tkfocus(rfr)
	tkgrid(tklabel(rfr,text="Available Teams:"),tklabel(rfr,text=" "),tklabel(rfr,text="Teams participating in the tournament:"),tklabel(rfr,text=" "))
	scroll.list.all.rfr<-tkscrollbar(rfr,command=function(...)tkyview(list.all.rfr,...))
	list.all.rfr<-tklistbox(rfr,width=35,yscrollcommand=function(...)tkset(scroll.list.all.rfr,...))
	scroll.list.sel.rfr<-tkscrollbar(rfr,command=function(...)tkyview(list.sel.rfr,...))
	list.sel.rfr<-tklistbox(rfr,width=35,yscrollcommand=function(...)tkset(scroll.list.sel.rfr,...))
	tkgrid(list.all.rfr,scroll.list.all.rfr,list.sel.rfr,scroll.list.sel.rfr)
	tkgrid.configure(scroll.list.all.rfr,sticky="nsw")
	tkgrid.configure(scroll.list.sel.rfr,sticky="nsw")
	for (i in all.teams) {
		tkinsert(list.all.rfr,"end",i)
	}
	remain<<-all.teams
	button.add.remove.function<-function() {
		if (!is.na(as.integer(tclvalue(tkcurselection(list.all.rfr))))) {##ADD TO SELECTION
			pos.sel<-as.integer(tclvalue(tkcurselection(list.all.rfr)))
			remain<<-remain[-pos.sel-1]
			tkinsert(list.sel.rfr,"end",paste(tclvalue(tkget(list.all.rfr,pos.sel))))
			tkdelete(list.all.rfr,pos.sel)
		}
		if (!is.na(as.integer(tclvalue(tkcurselection(list.sel.rfr))))) {##REMOVE FROM SELECTION
			pos.sel<-as.integer(tclvalue(tkcurselection(list.sel.rfr)))
			team.name<-tclvalue(tkget(list.sel.rfr,pos.sel))
			remain<<-sort(c(remain,team.name))
			tkdelete(list.sel.rfr,pos.sel)
			pos2put<-(1:length(remain))[remain==team.name]
			tkinsert(list.all.rfr,pos2put-1,team.name)
		}
		if (as.integer(tclvalue(tkindex(list.sel.rfr,"end")))>1) {###ADJUST THE BUTTON STATE
			tkconfigure(but.rfr,state="normal",cursor="hand2")
		}else{
			tkconfigure(but.rfr,state="disabled",cursor="")
		}
	}
	button.all.function<-function() {
		if (as.integer(tclvalue(tkindex(list.sel.rfr,"end")))>0) {
			for (i in 1:as.integer(tclvalue(tkindex(list.sel.rfr,"end")))){
				tkdelete(list.sel.rfr,0)###CLEAR SELECT LIST
			}
			for (i in 1:as.integer(tclvalue(tkindex(list.all.rfr,"end")))){
				tkdelete(list.all.rfr,0)###CLEAR ALL LIST
			}
			for (i in all.teams) {
				tkinsert(list.all.rfr,"end",i)###WRITE WHOLE LIST IN ALL
			}
			remain<<-all.teams
		}else{
			for (i in 1:as.integer(tclvalue(tkindex(list.all.rfr,"end")))){
				tkdelete(list.all.rfr,0)####CLEAR ALL LIST
			}
			for (i in all.teams) {
				tkinsert(list.sel.rfr,"end",i)###WRITE WHOLE LIST IN SELECT
			}
			remain<<-NULL
		}
		if (as.integer(tclvalue(tkindex(list.sel.rfr,"end")))>1) {
			tkconfigure(but.rfr,state="normal",cursor="hand2")
		}else{
			tkconfigure(but.rfr,state="disabled",cursor="")
		}
	}
	tkgrid(tkbutton(rfr,text="Add/Remove Team",cursor="hand1",command=button.add.remove.function),tklabel(rfr,text=" "),tkbutton(rfr,text="Add/Remove All",cursor="sb_h_double_arrow",command=button.all.function),tklabel(rfr,text=" "))
	button.rfr<-function() {
			rep.times<-as.integer(tclvalue(tkget(text.rep.times,"0.0","end")))
			if (rep.times<=0) {
				tkmessageBox(title="Invalid Number",message=paste("You have requested an invalid number of simulations.\nThe procedure will continue by performing a single simulation.",sep=""),icon="error")
				rep.times<-1
				tkdelete(text.rep.times,"0.0","end")
				tkinsert(text.rep.times,"end","1")
			}
			refira<-tktoplevel()
			tkwm.title(refira,"Final Rank Reproduction")
			tkfocus(refira)
			tkconfigure(rfr,cursor="watch")
			tkconfigure(but.rfr,cursor="watch")
			modelo.coef2<-modelo.coef
			if (tclvalue(estimate.missing)=="1") {
				nas.pos<-(1:length(dedomena$scores))[is.na(dedomena$scores)]
				scores2<-as.integer(as.character(dedomena$scores))
				for (i in nas.pos) {
					scores2[i]<-rpois(1,exp(modelo.coef[modelo.pnames==paste("dedomena$scoring.teams",dedomena$scoring.teams[i],sep="")]+modelo.coef[modelo.pnames==paste("dedomena$opposing.teams",dedomena$opposing.teams[i],sep="")]+(dedomena$home.effect==1)*modelo.coef[modelo.pnames=="dedomena$home.effect1"]))
				}
				modelo2<-glm(scores2~dedomena$scoring.teams+dedomena$opposing.teams+dedomena$home.effect,family=poisson(link=log))
				no.coefs2<-length(names(modelo2$coef))
				modelo.coef2<-c(modelo2$coef[c(1,no.coefs2)],0,modelo2$coef[2:(no.coefs2/2)],0,modelo2$coef[(no.coefs2/2+1):(no.coefs2-1)])
			}
			refira.text.scr<-tkscrollbar(refira, repeatinterval=5,command=function(...)tkyview(refira.text,...))
			refira.text<-tktext(refira,bg="white",font="courier",yscrollcommand=function(...)tkset(refira.text.scr,...))
			tkinsert(refira.text,"end",paste("FINAL RANK REPRODUCTION RESULTS","\n",sep=""))
			no.teams<-as.integer(tclvalue(tkindex(list.sel.rfr,"end")))
			score<-rep(0,no.teams)
			team.names<-NULL
			for (i in 1:no.teams-1){
				team.names<-c(team.names,tclvalue(tkget(list.sel.rfr,i)))
			}

			if (rep.times==1) {###REP.TIMES=1
				for (i in 1:(no.teams-1)) {
					for (j in (i+1):no.teams) {
						boot.home<-rpois(1000,exp(modelo.coef2[modelo.pnames==paste("dedomena$scoring.teams",team.names[i],sep="")]+modelo.coef2[modelo.pnames==paste("dedomena$opposing.teams",team.names[j],sep="")]+modelo.coef2[modelo.pnames=="dedomena$home.effect1"]))
						boot.visit<-rpois(1000,exp(modelo.coef2[modelo.pnames==paste("dedomena$scoring.teams",team.names[j],sep="")]+modelo.coef2[modelo.pnames==paste("dedomena$opposing.teams",team.names[i],sep="")]))
						home.wins<-sum(boot.home>boot.visit)
						visit.wins<-sum(boot.home<boot.visit)
						case.tie<-sum(boot.home==boot.visit)
						score[i]<-score[i]+(0.003*home.wins)+(0.001*case.tie)
						score[j]<-score[j]+(0.003*visit.wins)+(0.001*case.tie)
						boot.home<-rpois(1000,exp(modelo.coef2[modelo.pnames==paste("dedomena$scoring.teams",team.names[j],sep="")]+modelo.coef2[modelo.pnames==paste("dedomena$opposing.teams",team.names[i],sep="")]+modelo.coef2[modelo.pnames=="dedomena$home.effect1"]))
						boot.visit<-rpois(1000,exp(modelo.coef2[modelo.pnames==paste("dedomena$scoring.teams",team.names[i],sep="")]+modelo.coef2[modelo.pnames==paste("dedomena$opposing.teams",team.names[j],sep="")]))
						home.wins<-sum(boot.home>boot.visit)
						visit.wins<-sum(boot.home<boot.visit)
						case.tie<-sum(boot.home==boot.visit)
						score[j]<-score[j]+(0.003*home.wins)+(0.001*case.tie)
						score[i]<-score[i]+(0.003*visit.wins)+(0.001*case.tie)
					}
				}
				team.ranks<-team.names[sort(score,decreasing=T,index.return=T)$ix]
				score.ranks<-sort(score,decreasing=T)
				dupl.ranks<-duplicated(score.ranks)
				actual.rank<-1:no.teams
				for (i in 1:no.teams) {
					if (dupl.ranks[i]) {actual.rank[i]<-actual.rank[i-1]}
					tkinsert(refira.text,"end",paste("RANK ",actual.rank[i],": ",team.ranks[i]," SCORE: ",round(score.ranks[i],1),"\n",sep=""))
				}
			}else{###REP.TIMES>1
				actual.ranks<-matrix(rep(1:no.teams,times=rep.times),byrow=F,ncol=rep.times)
				for (k in 1:rep.times) {
				for (i in 1:(no.teams-1)) {
					for (j in (i+1):no.teams) {
						boot.home<-rpois(1,exp(modelo.coef2[modelo.pnames==paste("dedomena$scoring.teams",team.names[i],sep="")]+modelo.coef2[modelo.pnames==paste("dedomena$opposing.teams",team.names[j],sep="")]+modelo.coef2[modelo.pnames=="dedomena$home.effect1"]))
						boot.visit<-rpois(1,exp(modelo.coef2[modelo.pnames==paste("dedomena$scoring.teams",team.names[j],sep="")]+modelo.coef2[modelo.pnames==paste("dedomena$opposing.teams",team.names[i],sep="")]))
						score[i]<-score[i]+3*(boot.home>boot.visit)
						score[j]<-score[j]+3*(boot.visit>boot.home)
						score[i]<-score[i]+1*(boot.visit==boot.home)
						score[j]<-score[j]+1*(boot.visit==boot.home)
						boot.home<-rpois(1,exp(modelo.coef2[modelo.pnames==paste("dedomena$scoring.teams",team.names[j],sep="")]+modelo.coef2[modelo.pnames==paste("dedomena$opposing.teams",team.names[i],sep="")]+modelo.coef2[modelo.pnames=="dedomena$home.effect1"]))
						boot.visit<-rpois(1,exp(modelo.coef2[modelo.pnames==paste("dedomena$scoring.teams",team.names[i],sep="")]+modelo.coef2[modelo.pnames==paste("dedomena$opposing.teams",team.names[j],sep="")]))
						score[j]<-score[j]+3*(boot.home>boot.visit)
						score[i]<-score[i]+3*(boot.visit>boot.home)
						score[i]<-score[i]+1*(boot.visit==boot.home)
						score[j]<-score[j]+1*(boot.visit==boot.home)
					}
				}
				actual.ranks[,k]<-sort(sort(score,decreasing=T,index.return=T)$ix,decreasing=F,index.return=T)$ix
				for (i in 1:no.teams){
					if (duplicated(score)[i]){
						d.score<-score[i]
						actual.ranks[i,k]<-min(sort(sort(score,decreasing=T,index.return=T)$ix,decreasing=F,index.return=T)$ix[score==d.score])
					}
				}
				}###END OF K
				actual.ranks<<-actual.ranks

				rank.table<-list()
				for (i in 1:no.teams) {
					rank.table[[i]]<-table(actual.ranks[i,])
				}
				mode.ranks<-rep(NA,no.teams)
				prob.ranks<-rep(NA,no.teams)
				for (i in 1:no.teams) {
					max.pos<-rank.table[[i]]==max(rank.table[[i]])
					mode.ranks[i]<-min(as.integer(row.names(rank.table[[i]])[max.pos]))###THE 'MIN' HELPS SOLVE RANK.POS VECTOR ISSUE, 'MAX' NOT USED SO THAT WE GET AN ATOMIC ELEMENT BUT HAVE A CORRECT DUPLICATE RANKING ORDER
					prob.ranks[i]<-max(round(sum(actual.ranks[i,]==mode.ranks[i])/rep.times*100,1))###'MAX' HELPS MAKE ATOMIC THE ELEMENT WHILE NOT AFFECTING PROB SINCE THEY BOTH SHOULD BE 50-50 ONCE WE HAVE SELF-EXCLUDING GAMES
				}
				mode.ranks.sorted<-sort(mode.ranks)
				for (i in mode.ranks.sorted[!duplicated(mode.ranks.sorted)]) {
					rank.pos<-(1:no.teams)[mode.ranks==i]###WARNING WHEN RANK.POS IS A VECTOR - TAKEN CARE OF
					for (j in rank.pos) {###CASE OF RANK.POS BEING A VECTOR
						tkinsert(refira.text,"end",paste("RANK ",i,": ",team.names[j]," with probability: ",prob.ranks[j],"%\n",sep=""))
					}###END OF CASE WHERE RANK.POS IS A VECTOR
				}
				tkinsert(refira.text,"end",paste("\n"))
				tkinsert(refira.text,"end",paste("TEAM RANKS PROBABILITY MATRIX"))
				tkinsert(refira.text,"end",paste("\n"))
				prob.matrix<-matrix(NA,nrow=no.teams,ncol=no.teams)
				for (i in 1:no.teams) {
					for (j in 1:no.teams) {
						prob.matrix[i,j]<-sum(actual.ranks[i,]==j)/rep.times
					}
				}
				prob.matrix<-round(prob.matrix,3)*100
				if (no.teams<6) {
					for (i in sort(mode.ranks,index=T)$ix) {
						tkinsert(refira.text,"end",format(team.names[i],width=16))
						for (j in 1:no.teams){
							tkinsert(refira.text,"end",paste("|",format(j,width=3),":",format(prob.matrix[i,j],width=5,nsmall=1),"%",sep=""))
						}
						tkinsert(refira.text,"end",paste("\n"))
						tkinsert(refira.text,"end",paste("\n"))
					}
				}else{
					for (i in sort(mode.ranks,index=T)$ix) {
						tkinsert(refira.text,"end",format(team.names[i],width=16))
						tkinsert(refira.text,"end",paste("\n"))
						for (j in 1:no.teams){
							if (prob.matrix[i,j]!=0) {
								tkinsert(refira.text,"end",paste("|",format(j,width=3),":",format(prob.matrix[i,j],width=5,nsmall=1),"%|\n",sep=""))
							}
						}
						tkinsert(refira.text,"end",paste("\n"))
						tkinsert(refira.text,"end",paste("\n"))
					}
				}
			}###END OF REP.TIMES
			if (tclvalue(estimate.missing)=="1") {tkinsert(refira.text,"end",paste("\nNOTE: The above ranking made use of missing value estimations","\n",sep=""))}
			tkinsert(refira.text,"end",paste("********************************************************************************","\n",sep=""))
			save.exit<-function(){
				cat(date(),tclvalue(tkget(refira.text,"0.0","end")),sep="\n",file=tclvalue(log.filename),append=TRUE)
				tkdestroy(refira)
			}
			txt.pop.menu<-tkmenu(refira.text, tearoff=FALSE)
			tkadd(txt.pop.menu, "command", label="Copy <Ctrl-C>",command=function() tcl("event","generate",.Tk.ID(refira.text),"<<Copy>>"))
			tkadd(txt.pop.menu,"separator")
			tkadd(txt.pop.menu, "command", label="Save & Close <Enter>",command=save.exit)
			tkadd(txt.pop.menu, "command", label="Exit & Don't Save <Esc>",command=function()tkdestroy(refira))
			right.click.pop <- function(x,y) {# x, y: mouse coordinates
				rootx <- as.integer(tkwinfo("rootx",refira.text))
				rooty <- as.integer(tkwinfo("rooty",refira.text))
				xTxt <- as.integer(x)+rootx
				yTxt <- as.integer(y)+rooty
				tcl("tk_popup",txt.pop.menu,xTxt,yTxt)
			}
			tkgrid(refira.text,refira.text.scr,columnspan=4)
			tkgrid.configure(refira.text.scr,sticky="nsw")
			tkgrid(tkbutton(refira,text="Save Results to log & Close",command=save.exit,cursor="hand2",font=tkfont.create(size=14,weight="bold",family="times",slant="italic")),tkbutton(refira,text="Exit without saving",cursor="X_cursor",command=function()tkdestroy(refira)),columnspan=2)
			pre.exit.routine<<-function(){
				per.val<-tkmessageBox(title="Output Window Shutting Down", message=paste("You are about to leave the output screen without saving the results to the log file.","\n","Would you like to save to log before doing so?",sep=""),type="yesnocancel",icon="question")
				if (tclvalue(per.val)=="yes") {save.exit()}
				if (tclvalue(per.val)=="no") {tkdestroy(refira)}
				tkfocus(rfr)
			}
			tcl("wm", "protocol", refira, "WM_DELETE_WINDOW", quote(pre.exit.routine()))
			tkbind(refira.text, "<Button-3>",right.click.pop)
			tkbind(refira,"<Return>",save.exit)
			tkbind(refira,"<Escape>",function()tcl("event","generate",.Tk.ID(refira),"<Alt-F4>")) ####ESCAPE BUTTONS EXITS
			tkconfigure(rfr,cursor="")
			tkconfigure(but.rfr,cursor="hand2")
			tkconfigure(refira.text,state="disabled")
	}
	list.focused<-tclVar(0)
	tkbind(list.all.rfr,"<Enter>",function()tclvalue(list.focused)<-1)
	tkbind(list.sel.rfr,"<Enter>",function()tclvalue(list.focused)<-2)
	list.scrolling<-function(D) {#####MOUSE WHEEL SCROLLING ALL LISTS
		if (tclvalue(list.focused)==1) {#MOUSE OVER TEAM LIST
			if (D<0) {tkyview(list.all.rfr,"scroll","+1","units")}
			if (D>0) {tkyview(list.all.rfr,"scroll","-1","units")}
		}
		if (tclvalue(list.focused)==2) {#MOUSE OVER HOME TEAM LIST
			if (D<0) {tkyview(list.sel.rfr,"scroll","+1","units")}
			if (D>0) {tkyview(list.sel.rfr,"scroll","-1","units")}
		}
	}#####END OF MOUSE WHEEL SCROLLING ALL LISTS
	tkbind(rfr,"<MouseWheel>",list.scrolling)
	but.rfr<-tkbutton(rfr,text="Reproduce Final Rank",command=button.rfr,font=tkfont.create(family="times",size=14,weight="bold",slant="italic"),state="disabled",cursor="")
	tkgrid(tklabel(rfr,text=" "))
	estimate.missing<-tclVar("0")
	exit.pos<-6
	if (sum(is.na(dedomena$scores))>0) {###THERE ARE MISSING VALUES SO MAKE THE OPTION VISIBLE
		tkgrid(tkcheckbutton(rfr,text=paste("Missing values should be estimated","\n","using the model prior to ranking",sep=""),variable=estimate.missing),columnspan=4)
		tkgrid(tklabel(rfr,text=" "))
		exit.pos<-exit.pos+2
	}###END OF VISUALIZING MISSING VALUES ESTIMATION OPTION WHEN NAs ARE PRESENT
	text.rep.times<-tktext(rfr,width=3,height=1)
	tkgrid(tklabel(rfr,text="Rank Reproduction Simulations :"),columnspan=3)
	tkgrid(text.rep.times,row=exit.pos-2,column=2)
	tkgrid(tklabel(rfr,text=""))
	tkinsert(text.rep.times,"end","1")
	tkgrid(but.rfr,columnspan=4)
	tkgrid(tkbutton(rfr,text="Exit",command=function()tkdestroy(rfr),cursor="X_cursor"),row=exit.pos,column=3)
	tkbind(rfr,"<Escape>",function()tkdestroy(rfr)) ####ESCAPE BUTTON EXITS
	pre.button.rfr<-function() {##TO AVOID BUTTON STATE OVERRIDE USING THE RETURN KEY
		if (tclvalue(tkcget(but.rfr,"-state"))=="normal") {button.rfr()}
	}
	tkbind(rfr,"<Return>",pre.button.rfr) ###ENTER CALLS MAIN ROUTINE
}
}######END OF MAJOR OPTIONS FUNCTION
button.proceed<-tkbutton(tt,text="Proceed",font=tkfont.create(family="times",size=18,weight="bold",slant="italic"),command=master.choice.check,state="disabled")
#####PROCEED BUTTON CREATION
clean.up<-function() {
	if(exists("log.filename",envir=.GlobalEnv)) {rm(log.filename,envir=.GlobalEnv)}
	if(exists("remain",envir=.GlobalEnv)) {rm(remain,envir=.GlobalEnv)}
	if(exists("pre.exit.routine",envir=.GlobalEnv)) {rm(pre.exit.routine,envir=.GlobalEnv)}
	tkdestroy(tt)
}
tcl("wm", "protocol", tt, "WM_DELETE_WINDOW", clean.up)
button.exit<-tkbutton(tt,text="Exit",cursor="X_cursor",font=tkfont.create(family="times",size=12),command=clean.up)
enter.button.choices<-function() {####WHEN ENTER IS PRESSED
	if (tclvalue(tkcget(button.proceed,"-state"))=="normal") {
		master.choice.check()
	}else{chooselogfile()}
}####END OF WHEN ENTER IS PRESSED
tkbind(tt,"<Return>",enter.button.choices)
tkbind(tt,"<Escape>",clean.up) ####ESCAPE BUTTONS EXITS

tkgrid(tklabel(tt,text=" "))###EMPTY LINE FOR MORE SPACE
tkgrid(button.proceed,button.exit)####PROCEED AND EXIT BUTTONS PLACED
	}######THE MATRIX IS VALID
} ###END OF DATA MATRIX CHECK#######
}#####END OF SELECTION BUTTON FOR LIST PRESSED
button.ok<-tkbutton(t1,text="    OK    ",cursor="hand2",font=tkfont.create(size=12,weight="bold"),command=data.matrix.selection)
tkgrid(tklabel(t1,text=" ")) ####EMPTY LINE FOR MORE SPACE
tkgrid(button.ok,tkbutton(t1,text="Exit",cursor="X_cursor",command=function()tkdestroy(t1)))
object.list.scrolling<-function(D) {####MOUSE WHEEL SCROLLING IN LIST
	if (D<0) {tkyview(object.list,"scroll","+1","units")}
	if (D>0) {tkyview(object.list,"scroll","-1","units")}
} ####END OF MOUSE WHEEL SCROLLING
tkbind(t1,"<MouseWheel>",object.list.scrolling)
tkbind(t1,"<Return>",data.matrix.selection)
tkbind(t1,"<Escape>",function()tkdestroy(t1))
#######THE STARTING LIST WINDOW CODE ENDS HERE

}
